{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

UNIT GErrors;


INTERFACE


IMPLEMENTATION


USES GUtils;


VAR
  ExitAddress: Pointer;


  PROCEDURE ErrorExit; FAR;
  VAR ErrStr:STRING;
  BEGIN
    ExitProc := ExitAddress;
    IF ErrorAddr <> NIL THEN
    BEGIN
      ClrScr(7);
      SetPal(OrgPal);
      Cursor(On);

      Writeln('ERROR CODE: ', ExitCode:3);
      Writeln('ERROR ADDRESS: '+PtrToHex(ErrorAddr));
      CASE ExitCode OF
            1..18 : Write('DOS ERROR: ');
         100..106 : Write('I/O ERROR: ');
         150..162,
         200..216 : Write('CRITICAL ERROR: ');
      END;
      CASE ExitCode OF
          1 : ErrStr := 'Invalid function number';
          2 : ErrStr := 'File not found';
          3 : ErrStr := 'Path not found';
          4 : ErrStr := 'Too many open files';
          5 : ErrStr := 'File access denied';
          6 : ErrStr := 'Invalid file handle';
         12 : ErrStr := 'Invalid file access code';
         15 : ErrStr := 'Invalid drive number';
         16 : ErrStr := 'Cannot remove current directory';
         17 : ErrStr := 'Cannot rename across drives';
         18 : ErrStr := 'No More Files';

        100 : ErrStr := 'Disk read error';
        101 : ErrStr := 'Disk write error';
        102 : ErrStr := 'File not assigned';
        103 : ErrStr := 'File not open';
        104 : ErrStr := 'File not open for input';
        105 : ErrStr := 'File not open for output';
        106 : ErrStr := 'Invalid numeric format';

        150 : ErrStr := 'Disk is write-protected';
        151 : ErrStr := 'Unknown unit';
        152 : ErrStr := 'Drive not ready';
        153 : ErrStr := 'Unknown command';
        154 : ErrStr := 'CRC error in data';
        155 : ErrStr := 'Bad drive request structure length';
        156 : ErrStr := 'Disk seek error';
        157 : ErrStr := 'Unknown media type';
        158 : ErrStr := 'Sector not found';
        159 : ErrStr := 'Printer out of paper';
        160 : ErrStr := 'Device write fault';
        161 : ErrStr := 'Device read fault';
        162 : ErrStr := 'Hardware failure';

        200 : ErrStr := 'Division by zero';
        201 : ErrStr := 'Range check error';
        202 : ErrStr := 'Stack overflow error';
        203 : ErrStr := 'Heap overflow error';
        204 : ErrStr := 'Invalid pointer operation';
        205 : ErrStr := 'Floating point overflow';
        206 : ErrStr := 'Floating point underflow';
        207 : ErrStr := 'Invalid floating point operation';
        208 : ErrStr := 'Overlay manager not installed';
        209 : ErrStr := 'Overlay file read error';
        210 : ErrStr := 'Object not initialized';
        211 : ErrStr := 'Call to abstract method';
        212 : ErrStr := 'Stream registration error';
        213 : ErrStr := 'Collection index out of range';
        214 : ErrStr := 'Collection overflow error';
        215 : ErrStr := 'Arithmetic overflow error';
        216 : ErrStr := 'General Protection fault';
      ELSE
        ErrStr := 'Unknown Error';
      END; {CASE}
      Writeln(ErrStr);

      ErrorAddr := NIL;
      Halt(ExitCode);
    END; {IF}
  END; {PROCEDURE}


BEGIN
  ExitAddress := ExitProc;
  ExitProc := @ErrorExit;
END.