{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ GodFather's STANDART DIALOGS UNIT Version 1.0 }
{ Copyright (C) 1996 By The GodFather }

UNIT GStdDlgs;


INTERFACE


USES Dos,                                 { Standart unit }
     GUtils, GMemory, GList, GDialogs;    { My own units  }


VAR
  XDlgPos        : Byte;
  YDlgPos        : Byte;
  DlgWidth       : Byte;
  Border         : FrameStyle;
  HorizCenterDlg : Boolean;
  VertCenterDlg  : Boolean;
  CustomPallette : Boolean;

  FileDialogHelp : Boolean;
  FileDialogFrame: Byte;
  FileDialogTitle: Byte;



PROCEDURE InfoBox      (StrOut:STRING; Warning:Boolean);
FUNCTION  PromptBox    (StrOut:STRING; Warning:Boolean): Boolean;
FUNCTION  AltPromptBox (StrOut:STRING; Warning:Boolean): Byte;
FUNCTION  FileDialog   (ATitle,AWildCard:STRING; VAR OutFile:STRING): Boolean;



IMPLEMENTATION



VAR
  Btns           : PButtons;
  DlgHeight      : Byte;
  XPos,YPos      : Byte;
  btnXPos,btnYPos: Byte;



PROCEDURE OpenBox(StrOut:STRING; Warning:Boolean);
BEGIN
  SaveCursor;
  Cursor(Off);
  IF HorizCenterDlg THEN XPos := (MaxX DIV 2) - (DlgWidth DIV 2)        ELSE XPos := XDlgPOS;
  IF VertCenterDlg  THEN YPos := (MaxY DIV 2) - Pred(DlgHeight DIV 2)-1 ELSE YPos := YDlgPOS;
  IF NOT CustomPallette THEN
    IF Warning
      THEN InitPallette(WarningDialogPAL)
      ELSE InitPallette(DefaultDialogPAL);
  OpenWin(XPos,YPos,DlgWidth,DlgHeight,DialogPallette[_DialogBack],
          DialogPallette[_DialogTitle],Border,'Information');
  WriteBetween(XPos,XPos+DlgWidth,YPos+3,DialogPallette[_DialogCommentsHighlight],StrOut);
  Btns := New(PButtons, Init);
END;


PROCEDURE InfoBox(StrOut:STRING; Warning:Boolean);
BEGIN
  OpenBox(StrOut,Warning);
  btnXPos := XPos + (DlgWidth DIV 2)-5;
  btnYPos := YPos + 6;
  WITH Btns^ DO
  BEGIN
    AddBtn('    ~O~K    ',kbAltO,btnXPos,btnYPos,btDefault);
    Process;
  END;
  RmWin;
  Dispose(Btns,Done);
  RestoreCursor;
END;


FUNCTION PromptBox(StrOut:STRING; Warning:Boolean): Boolean;
BEGIN
  OpenBox(StrOut,Warning);
  PromptBox := False;
  btnXPos := XPos + (DlgWidth DIV 2)-7;
  btnYPos := YPos + 6;
  WITH Btns^ DO
  BEGIN
    AddBtn('    ~O~K    ',kbAltO,btnXPos-7,btnYPos,btDefault);
    AddBtn('  ~C~ancel  ',kbAltC,btnXPos+11,btnYPos,btCancel);
    Process;
    IF CurrentPOS = 1 THEN PromptBox := True;
  END;
  RmWin;
  Dispose(Btns,Done);
  RestoreCursor;
END;


FUNCTION AltPromptBox(StrOut: STRING; Warning: Boolean): Byte;
BEGIN
  OpenBox(StrOut,Warning);
  btnXPos := XPos + (DlgWidth DIV 2)-14;
  btnYPos := YPos + 6;
  WITH Btns^ DO
  BEGIN
    AddBtn('    ~Y~es    ',kbAltY,btnXPos-6 ,btnYPos,btDefault);
    AddBtn('    ~N~o    ' ,kbAltN,btnXPos+10,btnYPos,btNormal);
    AddBtn('  ~C~ancel  ' ,kbAltC,btnXPos+25,btnYPos,btCancel);
    Process;
    AltPromptBox := CurrentPOS;
  END;
  RmWin;
  Dispose(Btns,Done);
  RestoreCursor;
END;



{===========================================================================}
{=== File Dialog ===========================================================}
{===========================================================================}
TYPE
  PFile   = ^TFile;
  TFile   = OBJECT(TObject)
    Name  : PString;
    Size  : LongInt;
    Attr  : Byte;
    Date  : LongInt;
    Dir   : Boolean;
    CONSTRUCTOR Init(AName:STRING;
                     ASize:LongInt;
                     AAttr:Byte;
                     ADate:LongInt);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PFilesList = ^TFilesList;
  TFilesList = OBJECT(TList)
     FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
     PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
     PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
  END;



VAR
  FileDlgX,
  FileDlgY,
  FileDL,
  FileLstLen  : Byte;

  Files       : PCollection;
  FilesList   : PFilesList;
  CurrentFile : PFile;

  OrigDir,
  CurrDir,
  OldDir,
  WildCard    : STRING[60];

  EnterExit   : Boolean;



{===========================================================================}
{=== Misc ROUTINES =========================================================}
{===========================================================================}
FUNCTION FormatFileName(FileName:STRING): STRING;
BEGIN
  FormatFileName := PadLeft(BaseNameOnly(FileName),8,' ')+' '+
                    PadLeft(ExtOnly(FileName),3,' ');
END;

FUNCTION AZ(A:LongInt): STRING;
VAR S:STRING[5];
BEGIN
  S:=IntToStr(A);
  IF Length(S) = 1 THEN S:='0'+S; AZ:=S;
END;



{===========================================================================}
{=== Help PROCEDURE ========================================================}
{===========================================================================}
PROCEDURE Help;
BEGIN
  OpenWin(FileDlgX+07,FileDlgY+02,46,12,$19,$1F,Double1,'File dialog HELP');
      Box(FileDlgX+12,FileDlgY+04,FileDlgX+48,FileDlgY+12,$19,Border);
FastWrite(FileDlgX+13,FileDlgY+04,$1E,' File dialog keys ');
  WriteHi(FileDlgX+13,FileDlgY+05,$17,$1A,' ~F1~        This screen');
  WriteHi(FileDlgX+13,FileDlgY+06,$17,$1A,' ~F9~        Return to startup dir');
  WriteHi(FileDlgX+13,FileDlgY+07,$17,$1A,' ~F10~       Change drive');
  WriteHi(FileDlgX+13,FileDlgY+08,$17,$1A,' ~- BSpace~  Exit directory');
  WriteHi(FileDlgX+13,FileDlgY+09,$17,$1A,' ~+ Enter~   Enter directory');
  WriteHi(FileDlgX+13,FileDlgY+10,$17,$1A,' ~Enter~     Choose file');
  WriteHi(FileDlgX+13,FileDlgY+11,$17,$1A,' ~Esc~       Exit');
  Pause;
  RmWin;
END;




{===========================================================================}
{=== TFile OBJECT ==========================================================}
{===========================================================================}
CONSTRUCTOR TFile.Init(AName:STRING; ASize:LongInt; AAttr:Byte; ADate:LongInt);
BEGIN
  Name := NewStr(AName);
  Size := ASize;
  Attr := AAttr;
  Date := ADate;
  IF (Attr AND Directory) <> 0 THEN Dir := True ELSE Dir := False;
END;

DESTRUCTOR TFile.Done;
BEGIN
  DisposeStr(Name);
END;




{===========================================================================}
{=== File operations =======================================================}
{===========================================================================}
PROCEDURE ReadFiles;
VAR Dir: SearchRec; Where: STRING;
BEGIN
  IF Length(CurrDir) = 3
    THEN Where := CurrDir
    ELSE Where := CurrDir + '\';
  New(Files,Init(1,1));

  FindFirst(Where+'*.*',Directory, Dir);
  WHILE DosError = 0 DO
  BEGIN
    IF (Dir.Name[1] <> '.') AND
       ((Dir.Attr AND Directory)<>0)
      THEN Files^.Insert(New(PFile,Init(Dir.Name,Dir.Size,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read directories}

  FindFirst(Where+WildCard,AnyFile AND NOT (VolumeID OR Directory OR SysFile), Dir);
  WHILE DosError = 0 DO
  BEGIN
    Files^.Insert(New(PFile,Init(Dir.Name,Dir.Size,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read files}

  IF Files^.Count  = 0 THEN Files^.Insert(New(PFile,Init('No files',0,0,0)));
END;


PROCEDURE NewDir;
VAR AFile:PFile; I: Integer;
BEGIN
  Dispose(Files,Done);
  ReadFiles;
  WITH FilesList^ DO
  BEGIN
    FilesList^.ChangeMaxTopics(FileLstLen, Files^.Count);
    IF OldDir = ''
      THEN LSTPosition := 1
      ELSE BEGIN
             FOR I := 0 TO Files^.Count-1 DO
             BEGIN
               AFile := Files^.At(I);
               IF AFile^.Name^ = OldDir
                 THEN BEGIN
                        LSTPosition := I+1;
                        Break;
                      END;
             END;
           END;
    ReDraw;
  END;
END;


PROCEDURE ExitDir;
VAR TMP: STRING; I: Byte; CH: Char;
BEGIN
  TMP := CurrDir;
  IF Length(TMP) > 3 THEN
  BEGIN
    I      := LastPos('\',TMP);
    OldDir := Copy(TMP,I+1,255);
    Delete(TMP,I,255);
    IF Length(TMP) = 2 THEN TMP := TMP+'\';
    ChDir(TMP);
    CurrDir := TMP;
    NewDir;
  END;
END;


PROCEDURE EnterDir;
VAR TMP:STRING;
BEGIN
  IF NOT CurrentFile^.Dir THEN Exit;
  IF CurrentFile^.Name^ = 'No files' THEN
  BEGIN
    ExitDir;
    Exit;
  END;
  OldDir := '';
  Tmp    := CurrentFile^.Name^;
  IF Length(CurrDir) = 3
    THEN CurrDir := CurrDir +      TMP
    ELSE CurrDir := CurrDir + '\'+ TMP;
  ChDir(CurrDir);
  NewDir;
END;


PROCEDURE ChDrive;
LABEL Quit;
VAR ESC:Boolean; Key:Word; Tmp:STRING;
BEGIN
  ESC := False;
  OpenWin  (FileDlgX+09,FileDlgY+6,42,4,$19,$1F,Special2,'Change drive');
  FastWrite(FileDlgX+17,FileDlgY+8,$17,'Enter new drive letter [ ]');
  FastWrite(FileDlgX+41,FileDlgY+8,$1E,CurrDir[1]);
  Tmp := '!';
  Key := Ord(UpCase(Chr(GetKey)));
  IF Key = 27 THEN ESC := True;
  IF (Chr(Key) = CurrDir[1]) THEN GOTO Quit;
  IF (Chr(Key) >= 'A') AND (Chr(Key) <= 'Z') THEN Tmp := Chr(Key)+':\';
  IF NOT ESC THEN FastWrite(FileDlgX+41,FileDlgY+8,$1E,Tmp[1]);
  {$I-} ChDir(Tmp); {$I+}
  IF IOResult = 0 THEN
  BEGIN
    RmWin;
    GetDir(0,CurrDir);
    NewDir; Exit;
  END;
Quit:
  RmWin;
END;




{===========================================================================}
{=== TFilesList OBJECT =====================================================}
{===========================================================================}
FUNCTION TFilesList.__GetLine(ListPos:Integer): STRING;
VAR AFile:PFile; Dt:DateTime; OutStr:STRING; SDate:STRING[20];
BEGIN
  AFile := Files^.At(ListPos-1);
  WITH AFile^ DO
  BEGIN
    IF Dir
      THEN OutStr := FormatFileName(Name^)+PadLeft(' <DIR>',12,' ')
      ELSE OutStr := FormatFileName(Name^)+PadRight(AddComas(Size),12,' ');

    OutStr := Concat('  ',OutStr,'  ');
    IF (Attr AND ReadOnly)  <> 0 THEN OutStr := Concat(OutStr,'R') ELSE OutStr := Concat(OutStr,'-');
    IF (Attr AND Hidden)    <> 0 THEN OutStr := Concat(OutStr,'H') ELSE OutStr := Concat(OutStr,'-');
    IF (Attr AND SysFile)   <> 0 THEN OutStr := Concat(OutStr,'S') ELSE OutStr := Concat(OutStr,'-');
    IF (Attr AND Archive)   <> 0 THEN OutStr := Concat(OutStr,'A') ELSE OutStr := Concat(OutStr,'-');
    UnpackTime(Date, DT);
    WITH DT DO OutStr := OutStr+'  '+AZ(Day) +'-'+AZ(Month)+'-'+AZ(Year)+
                                '  '+AZ(Hour)+':'+AZ(Min);
    IF Name^ = 'No files' THEN OutStr := PadCenter('No files in this directory',56,' ');
  END;
  __GetLine := OutStr;
END;


PROCEDURE TFilesList.__IdleListCall(ListPos:Integer);
VAR AFile:PFile; StrOut:STRING;
BEGIN
  AFile  := Files^.At(ListPos-1);
  IF Length(CurrDir) = 3
    THEN StrOut := CurrDir+    WildCard
    ELSE StrOut := CurrDir+'\'+WildCard;
  FastWrite(FileDlgX+4,FileDL+5,$17,PadLeft(StrOut,54,' '));
  WITH AFile^ DO
  BEGIN
    IF Name^ <> 'No files'
      THEN BEGIN
             FastWrite(FileDlgX+4,FileDL+6,$17,StripLeft(__GetLine(ListPos),' '));
             IF Dir
               THEN FastWrite(FileDlgX+4,FileDlgY+2,FileDialogFrame,Replicate(15,#196))
               ELSE FastWrite(FileDlgX+5,FileDlgY+2,FileDialogTitle,' '+FormatFileName(Name^)+' ');
           END
      ELSE BEGIN
             FastWrite(FileDlgX+4,FileDlgY+2,FileDialogFrame,Replicate(15,#196));
             FastWrite(FileDlgX+4,FileDL+6,$17,PadLeft(__GetLine(ListPos),54,' '));
           END;
  END;
END;


PROCEDURE TFilesList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
BEGIN
  CurrentFile := Files^.At(ListPos-1);
  CASE PressedKey OF
     Ord('-'),
     kbBSpace: ExitDir;
     Ord('+'): EnterDir;

         kbF1: IF FileDialogHelp THEN Help;
         kbF9: BEGIN
                 {$I-}
                   ChDir(OrigDir);
                 {$I+}
                 IF IOResult = 0
                   THEN BEGIN
                          GetDir(0,CurrDir);
                          LSTPosition := 1;
                          NewDir;
                        END;
               END;
        kbF10: ChDrive;
        kbEsc: EnterExit := False;
      kbEnter: BEGIN
                 IF CurrentFile^.Dir
                   THEN EnterDir
                   ELSE IF (CurrentFile^.Name^ = 'No files')
                          THEN ExitDir
                          ELSE EndOfList := True;
            END;
  END;
END;




{===========================================================================}
{=== Main PROCEDURE ========================================================}
{===========================================================================}
FUNCTION FileDialog(ATitle,AWildCard:STRING; VAR OutFile:STRING): Boolean;
BEGIN
  GetDir(0,OrigDir);
  EnterExit  := True;
  CurrDir    := FExpand(OrigDir);
  WildCard   := AdjCase(Upper, AWildCard);
  FileDlgX   := 10;
  FileDlgY   := MaxY DIV 2 - 7;
  FileLstLen := 9;
  FileDL     := FileDlgY+FileLstLen;
  OpenWin(FileDlgX,FileDlgY,60,FileLstLen+7,FileDialogFrame,FileDialogTitle,Border,ATitle);
  Box       (FileDlgX+3,FileDlgY+2,FileDlgX+57,FileDL+3,FileDialogFrame,Border);
  ClearText (FileDlgX+3,FileDL+5  ,FileDlgX+57,FileDL+6,$17);
  ReadFiles;
  FilesList := New(PFilesList,
                        Init(FileDlgX+4,FileDlgY+3,
                             53,FileLstLen,
                             Files^.Count,
                             False,
                             True,FileDlgX+6,FileDL+3,#196,
                             True,FileDlgX+57,FileDlgY+3,FileDL+2,
                             lPurplePal));

  FilesList^.Pallette[lScroller] := FileDialogFrame;
  FilesList^.Pallette[lFastFind] := FileDialogFrame;

  FilesList^.Process;

  FileDialog := EnterExit;
  IF EnterExit THEN OutFile := FExpand(CurrentFile^.Name^);

  Dispose(FilesList,Done);
  Dispose(Files,Done);

  {$I-} ChDir(OrigDir); {$I+}
  RmWin;
END;




{ INITIALIZATION PART OF THE UNIT }

BEGIN
  XDlgPos        := 15;
  YDlgPos        := 8;
  DlgWidth       := 52;
  DlgHeight      := 8;
  VertCenterDlg  := True;
  HorizCenterDlg := False;
  CustomPallette := False;
  Border         := Single1;

  FileDialogFrame:= $5D;
  FileDialogTitle:= $5E;
  FileDialogHelp := True;
END.