{$A+,B-,E-,F+,I-,L-,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ Copyright (C) 1994-96 By The GodFather }

UNIT GButtons;

INTERFACE

USES GUtils,
     GMemory;

TYPE
  PButton = ^TButton;
  TButton = OBJECT(TObject)
    Name  : PString;
    XPos,
    YPos  : Byte;
    Norm  : Byte;
    Activ : Byte;
    Shad  : Byte;
    CONSTRUCTOR Init(aXPos,aYPos,aNorm,aActiv:Byte; aName:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PButtons = ^TButtons;
  TButtons = OBJECT(TCollection)
    DefaultBPos: Word;
    CurrentBPos: Word;
    ENTERTerminate: Boolean;
    FUNCTION ButtonsFirstCalled: Word; VIRTUAL;
    FUNCTION ProcessButtons: Integer; VIRTUAL;
    PROCEDURE ButtonsKeyHook(VAR Key: Word); VIRTUAL;
    PROCEDURE AddButton(aXPos,aYPos,aNorm,aActiv:Byte; aName:STRING); VIRTUAL;
    PROCEDURE Update(aPos:Word; Active:Boolean); VIRTUAL;
    PROCEDURE PushButton(aPos:Word); VIRTUAL;
    PROCEDURE ReDrawButton(aPos:Word); VIRTUAL;
    PROCEDURE ReDrawAllButtons; VIRTUAL;
    CONSTRUCTOR Init(aDefaultBPos:Word);
  END;

IMPLEMENTATION

{----------------------------------------------------------------------------}
{                              TBUTTON PINIZ                                 }
{----------------------------------------------------------------------------}
CONSTRUCTOR TButton.Init(aXPos,aYPos,aNorm,aActiv:Byte; aName:STRING);
VAR A: Byte;
BEGIN
  Name := NewStr(aName);
  XPos := aXPos;
  YPos := aYPos;
  Norm := aNorm;
  Activ:= aActiv;
  A    := GetScreenAttr(XPos+1,YPos+1);
  IF A <= 15
    THEN Shad := 8
    ELSE Shad := Attr(0,A DIV 16);
END;

DESTRUCTOR TButton.Done;
BEGIN
  DisposeStr(Name);
END;

{----------------------------------------------------------------------------}
{                              TBUTTONS PINIZ                                }
{----------------------------------------------------------------------------}
FUNCTION TButtons.ButtonsFirstCalled: Word; BEGIN END;
PROCEDURE TButtons.ButtonsKeyHook(VAR Key: Word); BEGIN END;

PROCEDURE TButtons.AddButton(aXPos,aYPos,aNorm,aActiv:Byte; aName:STRING);
BEGIN
  IF (aXPos+Length(aName)+1 > MaxX) THEN aXPos := MaxX-Length(aName)-1;
  IF (aYPos + 1 > MaxY) THEN aYPos := MaxY-1;
  Insert(New(PButton,Init(aXPos,aYPos,aNorm,aActiv,aName)));
END;

PROCEDURE TButtons.PushButton(aPos: Word);
VAR BName: STRING; BSize: Byte; aButton: PButton;
BEGIN
  aButton := At(CurrentBPos);
  BName   := aButton^.Name^;
  BSize   := Length(BName);
  WITH aButton^ DO
  BEGIN
    BName[1] := #16;
    BName[Length(BName)] := #17;
    FastWrite(XPos,YPos,Shad,' ');
    FastWrite(XPos+1,YPos,Activ,BName);
    FastWrite(XPos+1,YPos+1,Shad,Replicate(BSize,' '));
    Wait(2);
    FastWrite(XPos,YPos,Activ,BName);
    FastWrite(XPos+BSize,YPos,Shad,'');
    FastWrite(XPos+1,YPos+1,Shad,Replicate(BSize,''));
    Wait(1);
  END;
END;

PROCEDURE TButtons.Update(aPos: Word; Active: Boolean);
VAR BName: STRING; aButton: PButton; Attr: Byte;
BEGIN
  aButton := At(aPos);
  BName   := aButton^.Name^;
  WITH aButton^ DO
  BEGIN
    IF Active
      THEN Attr := Activ
      ELSE Attr := Norm;
    IF Active THEN
    BEGIN
      BName[1] := #16;
      BName[Length(BName)] := #17;
    END;
    FastWrite(XPos,YPos,Attr,BName);
  END;
END;

PROCEDURE TButtons.ReDrawButton(aPos: Word);
VAR aButton: PButton;
BEGIN
  Update(aPos,False);
  aButton := At(aPos);
  WITH aButton^ DO
  BEGIN
    FastWrite(XPos+Length(Name^),YPos,Shad,'');
    FastWrite(XPos+1,YPos+1,Shad,Replicate(Length(Name^),''));
  END;
END;

PROCEDURE TButtons.ReDrawAllButtons;
VAR I: Word;
BEGIN
  FOR I:=0 TO Count-1 DO ReDrawButton(I);
END;

FUNCTION TButtons.ProcessButtons: Integer;
VAR Key: Word; Terminate: Boolean; TempKey: Word;
BEGIN
  ReDrawAllButtons;
  Terminate   := False;
  CurrentBPos := DefaultBPos;
  Update(CurrentBPos,True);
  TempKey     := ButtonsFirstCalled;
  REPEAT
    IF TempKey = 0
      THEN Key := GetKey
      ELSE Key := TempKey;
    TempKey := 0;
    ButtonsKeyHook(Key);
    CASE Key OF
      kbUp,
      kbLeft,
      kbDown,
      kbRight:
      BEGIN
        Update(CurrentBPos,False);
        IF (Key = kbUp) OR (Key = kbLeft)
          THEN IF CurrentBPos = 0
                 THEN CurrentBPos := Count - 1
                 ELSE Dec(CurrentBPos);
        IF (Key = kbDown) OR (Key = kbRight)
          THEN IF CurrentBPos = Count - 1
                 THEN CurrentBPos := 0
                 ELSE Inc(CurrentBPos);
        Update(CurrentBPos,True);
      END;

      kbEnter,
      kbSpace : BEGIN
                  PushButton(CurrentBPos);
                  IF ENTERTerminate
                    THEN Terminate := True
                    ELSE Terminate := False;
                END;
      kbEsc   : Terminate := True;
   END;
  UNTIL Terminate;
  ProcessButtons := CurrentBPos+1;
  IF Key = kbEsc THEN ProcessButtons := -1;
END;

CONSTRUCTOR TButtons.Init(aDefaultBPos:Word);
BEGIN
  INHERITED Init(1,1);
  DefaultBPos    := aDefaultBPos-1;
  ENTERTerminate := True;
END;

END.
